"""
    The Country Network Live Add-on

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import sys, re, os, urllib, urllib2, json
from urllib2 import urlopen
import xbmc, xbmcgui, xbmcplugin, xbmcaddon

dlg = xbmcgui.Dialog()
addon = xbmcaddon.Addon()
addon_name = addon.getAddonInfo('name')
addon_id = addon.getAddonInfo('id')
plugin_path = xbmcaddon.Addon(id=addon_id).getAddonInfo('path')
addon_logo = xbmc.translatePath(os.path.join(plugin_path, 'tvaddons_logo.png'))
site_url = "http://tcncountry.net/watch-live.htm"
embed_match_string = '<iframe src="(.+?)"'
tokens_match_string = '<script id="(.+?)"'
json_url_main = 'http://json.dacast.com/b/'


def find_single_match(text, pattern):
    result = ""
    try:
        matches = re.findall(pattern, text, flags=re.DOTALL)
        result = matches[0]
    except:
        result = ""
    return result


def cleanHex(text):
    def fixup(m):
        text = m.group(0)
        if text[:3] == "&#x":
            return unichr(int(text[3:-1], 16)).encode('utf-8')
        else:
            return unichr(int(text[2:-1])).encode('utf-8')

    try:
        return re.sub("(?i)&#\w+;", fixup, text.decode('ISO-8859-1').encode('utf-8'))
    except:
        return re.sub("(?i)&#\w+;", fixup, text.encode("ascii", "ignore").encode('utf-8'))


def open_url(url):
    req = urllib2.Request(url)
    req.add_header('User-Agent',
                   'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
    response = urllib2.urlopen(req)
    link = response.read()
    link = cleanHex(link)
    response.close()
    return link


if __name__ == '__main__':
    xbmcgui.Dialog().notification(addon_name + ' is provided by:', 'www.tvaddons.co', addon_logo, 10000, False)

    # Get embed url
    link = open_url(site_url)
    embed_url = find_single_match(link, embed_match_string)

    # Get tokens
    link = open_url(embed_url)
    tokens = find_single_match(link, tokens_match_string).replace("_", "/")

    # Build json url
    json_url = json_url_main + tokens

    # Get stream url
    link = open_url(json_url)
    json = json.loads(link)
    stream = "http:" + json["hls"] + "?rebase=on"

    if "m3u8" in stream:
        xbmc.executebuiltin('Activatewindow(home)')
        li = xbmcgui.ListItem(addon_name)
        xbmc.Player().play(stream, li, False)
    else:
        dlg.ok(addon_name, "Unable to get stream. Please try again later.")
        xbmc.executebuiltin('Activatewindow(home)')
